Public Class TreeNodeEx
    Inherits System.Windows.Forms.TreeNode

    Public Sub New()
        InitializeComponent()
    End Sub

    Public Sub New(ByVal [text] As String)
        MyBase.New([text])
        InitializeComponent()
    End Sub

    Public Sub New(ByVal [text] As String, ByVal children() As TreeNodeEx)
        MyBase.New([text], children)
        InitializeComponent()
    End Sub

    Public Sub New(ByVal [text] As String, ByVal imageIndex As Integer, ByVal selectedImageIndex As Integer)
        MyBase.New([text], imageIndex, selectedImageIndex)
        InitializeComponent()
    End Sub

    Public Sub New(ByVal [text] As String, ByVal imageIndex As Integer, ByVal selectedImageIndex As Integer, ByVal children() As TreeNodeEx)
        MyBase.New([text], imageIndex, selectedImageIndex, children)
        InitializeComponent()
    End Sub

    Private Sub InitializeComponent()
        isSubFoldersAdded = False
    End Sub

    Private isSubFoldersAdded As Boolean
    Public Property SubFoldersAdded() As Boolean
        Get
            Return isSubFoldersAdded
        End Get
        Set(ByVal Value As Boolean)
            isSubFoldersAdded = Value
        End Set
    End Property
End Class